unit Pswd;
{===============================================================================
 Paradox database version upgrade demo application.
 Roman Krejci-RKS, Pujmanove 1552, 140 00 Prague 4, Czech Republic
 http://www.rksolution.cz, EMail INFO@rksolution.cz


 This unit implements callback for unknown password retrieval.
 (see PXUPGR.DLL function pxupRegisterPswdCallback)
 ===============================================================================}

interface
uses windows, Sysutils, StdCtrls, Controls, Classes, Forms;



type
  TFormPswd = class(TForm)
    Edit1: TEdit;
    btnOK: TButton;
    Label1: TLabel;
    btnAbort: TButton;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


{ Callback for unknown password retrieval. Callback can be registered
  by calling PXUPGR.DLL exported routine pxupRegisterPswdCallback.}
Function UnknownPasswordCallback(szTablename: pChar): pChar; stdcall;

implementation

{$R *.DFM}

const
{$I PSWD.INC} { contains string constants to be translated }
  MaxPasswLen  = 15; { maximum Paradox password length }

Var
{ MUST be global var because its address should be valid
  after UnknownPasswordCallback exits }
  ThePassword: array [0..MaxPasswLen] of Char;

Function UnknownPasswordCallback(szTablename: pChar): pChar; stdcall;
Var OldCursor: hCursor;
begin
  Result := nil;
  OldCursor := Screen.Cursor;
  Screen.Cursor := crDefault;
  Try
    with TFormPswd.Create(Application) do TRY
      label1.caption := Format(msg_TableIsPasswordprotected,[szTablename]);
      case Showmodal of
      mrOK : begin
          if (length(Edit1.text) <= MaxPasswLen) and
             (length(Edit1.text) > 0) then begin
            StrPCopy(ThePassword,edit1.text);
            result := @ThePassword;
          end;
        end;
      mrAbort: ;
      end; { Case }
    Finally
      Free;
    End; { Try }
  Finally
    Screen.Cursor := OldCursor;
  End; { Try }
end;

{ event handlers }

procedure TFormPswd.FormCreate(Sender: TObject);
begin
  caption := frm_caption;
  btnOK.caption := frm_btnOKCaption;
  btnAbort.caption := frm_btnAbortCaption;
  Edit1.maxLength := MaxPasswLen;
end;

end.
